import{s as Te,n as ve,o as He}from"../chunks/scheduler.85c25b89.js";import{S as ke,i as Je,g as i,s as a,r as o,A as je,h as m,f as n,c as s,j as xe,u as h,x as u,k as Me,y as Ce,a as l,v as p,d as r,t as d,w as g}from"../chunks/index.c9837788.js";import{C as P}from"../chunks/CodeBlock.52fa569e.js";import{H as pe,E as Ze}from"../chunks/EditOnGithub.b65eee75.js";function We(re){let f,V,Q,E,$,F,c,de="The <code>timm</code> library has a built-in integration with the Hugging Face Hub, making it easy to share and load models from the 🤗 Hub.",S,b,ge="In this short guide, we’ll see how to:",N,w,ue="<li>Share a <code>timm</code> model on the Hub</li> <li>How to load that model back from the Hub</li>",I,y,R,_,fe="First, you’ll need to make sure you have the <code>huggingface_hub</code> package installed.",z,x,B,M,$e="Then, you’ll need to authenticate yourself. You can do this by running the following command:",A,T,D,v,ce="Or, if you’re using a notebook, you can use the <code>notebook_login</code> helper:",O,H,q,k,K,J,ee,j,be="Here is where you would normally train or fine-tune the model. We’ll skip that for the sake of this tutorial.",te,C,we="Let’s pretend we’ve now fine-tuned the model. The next step would be to push it to the Hub! We can do this with the <code>timm.models.hub.push_to_hf_hub</code> function.",ne,Z,le,W,ye="Running the above would push the model to <code>&lt;your-username&gt;/resnet18-random</code> on the Hub. You can now share this model with your friends, or use it in your own code!",ae,L,se,U,_e='Loading a model from the Hub is as simple as calling <code>timm.create_model</code> with the <code>pretrained</code> argument set to the name of the model you want to load. In this case, we’ll use <a href="https://huggingface.co/nateraw/resnet18-random" rel="nofollow"><code>nateraw/resnet18-random</code></a>, which is the model we just pushed to the Hub.',ie,G,me,Y,oe,X,he;return $=new pe({props:{title:"Sharing and Loading Models From the Hugging Face Hub",local:"sharing-and-loading-models-from-the-hugging-face-hub",headingTag:"h1"}}),y=new pe({props:{title:"Authenticating",local:"authenticating",headingTag:"h2"}}),x=new P({props:{code:"cGlwJTIwaW5zdGFsbCUyMGh1Z2dpbmdmYWNlX2h1Yg==",highlighted:"pip install huggingface_hub",wrap:!1}}),T=new P({props:{code:"aHVnZ2luZ2ZhY2UtY2xpJTIwbG9naW4=",highlighted:"huggingface-cli login",wrap:!1}}),H=new P({props:{code:"ZnJvbSUyMGh1Z2dpbmdmYWNlX2h1YiUyMGltcG9ydCUyMG5vdGVib29rX2xvZ2luJTBBbm90ZWJvb2tfbG9naW4oKQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> notebook_login
<span class="hljs-meta">&gt;&gt;&gt; </span>notebook_login()`,wrap:!1}}),k=new pe({props:{title:"Sharing a Model",local:"sharing-a-model",headingTag:"h2"}}),J=new P({props:{code:"aW1wb3J0JTIwdGltbSUwQW1vZGVsJTIwJTNEJTIwdGltbS5jcmVhdGVfbW9kZWwoJ3Jlc25ldDE4JyUyQyUyMHByZXRyYWluZWQlM0RUcnVlJTJDJTIwbnVtX2NsYXNzZXMlM0Q0KQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> timm
<span class="hljs-meta">&gt;&gt;&gt; </span>model = timm.create_model(<span class="hljs-string">&#x27;resnet18&#x27;</span>, pretrained=<span class="hljs-literal">True</span>, num_classes=<span class="hljs-number">4</span>)`,wrap:!1}}),Z=new P({props:{code:"bW9kZWxfY2ZnJTIwJTNEJTIwZGljdChsYWJlbF9uYW1lcyUzRCU1QidhJyUyQyUyMCdiJyUyQyUyMCdjJyUyQyUyMCdkJyU1RCklMEF0aW1tLm1vZGVscy5wdXNoX3RvX2hmX2h1Yihtb2RlbCUyQyUyMCdyZXNuZXQxOC1yYW5kb20nJTJDJTIwbW9kZWxfY29uZmlnJTNEbW9kZWxfY2ZnKQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>model_cfg = <span class="hljs-built_in">dict</span>(label_names=[<span class="hljs-string">&#x27;a&#x27;</span>, <span class="hljs-string">&#x27;b&#x27;</span>, <span class="hljs-string">&#x27;c&#x27;</span>, <span class="hljs-string">&#x27;d&#x27;</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>timm.models.push_to_hf_hub(model, <span class="hljs-string">&#x27;resnet18-random&#x27;</span>, model_config=model_cfg)`,wrap:!1}}),L=new pe({props:{title:"Loading a Model",local:"loading-a-model",headingTag:"h2"}}),G=new P({props:{code:"bW9kZWxfcmVsb2FkZWQlMjAlM0QlMjB0aW1tLmNyZWF0ZV9tb2RlbCgnaGZfaHViJTNBbmF0ZXJhdyUyRnJlc25ldDE4LXJhbmRvbSclMkMlMjBwcmV0cmFpbmVkJTNEVHJ1ZSk=",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>model_reloaded = timm.create_model(<span class="hljs-string">&#x27;hf_hub:nateraw/resnet18-random&#x27;</span>, pretrained=<span class="hljs-literal">True</span>)',wrap:!1}}),Y=new Ze({props:{source:"https://github.com/huggingface/pytorch-image-models/blob/main/hfdocs/source/hf_hub.mdx"}}),{c(){f=i("meta"),V=a(),Q=i("p"),E=a(),o($.$$.fragment),F=a(),c=i("p"),c.innerHTML=de,S=a(),b=i("p"),b.textContent=ge,N=a(),w=i("ol"),w.innerHTML=ue,I=a(),o(y.$$.fragment),R=a(),_=i("p"),_.innerHTML=fe,z=a(),o(x.$$.fragment),B=a(),M=i("p"),M.textContent=$e,A=a(),o(T.$$.fragment),D=a(),v=i("p"),v.innerHTML=ce,O=a(),o(H.$$.fragment),q=a(),o(k.$$.fragment),K=a(),o(J.$$.fragment),ee=a(),j=i("p"),j.textContent=be,te=a(),C=i("p"),C.innerHTML=we,ne=a(),o(Z.$$.fragment),le=a(),W=i("p"),W.innerHTML=ye,ae=a(),o(L.$$.fragment),se=a(),U=i("p"),U.innerHTML=_e,ie=a(),o(G.$$.fragment),me=a(),o(Y.$$.fragment),oe=a(),X=i("p"),this.h()},l(e){const t=je("svelte-u9bgzb",document.head);f=m(t,"META",{name:!0,content:!0}),t.forEach(n),V=s(e),Q=m(e,"P",{}),xe(Q).forEach(n),E=s(e),h($.$$.fragment,e),F=s(e),c=m(e,"P",{"data-svelte-h":!0}),u(c)!=="svelte-1lmv8hz"&&(c.innerHTML=de),S=s(e),b=m(e,"P",{"data-svelte-h":!0}),u(b)!=="svelte-11r33nm"&&(b.textContent=ge),N=s(e),w=m(e,"OL",{"data-svelte-h":!0}),u(w)!=="svelte-1t5ulh6"&&(w.innerHTML=ue),I=s(e),h(y.$$.fragment,e),R=s(e),_=m(e,"P",{"data-svelte-h":!0}),u(_)!=="svelte-18o00ln"&&(_.innerHTML=fe),z=s(e),h(x.$$.fragment,e),B=s(e),M=m(e,"P",{"data-svelte-h":!0}),u(M)!=="svelte-1dqusp5"&&(M.textContent=$e),A=s(e),h(T.$$.fragment,e),D=s(e),v=m(e,"P",{"data-svelte-h":!0}),u(v)!=="svelte-yj2stu"&&(v.innerHTML=ce),O=s(e),h(H.$$.fragment,e),q=s(e),h(k.$$.fragment,e),K=s(e),h(J.$$.fragment,e),ee=s(e),j=m(e,"P",{"data-svelte-h":!0}),u(j)!=="svelte-1d50rfn"&&(j.textContent=be),te=s(e),C=m(e,"P",{"data-svelte-h":!0}),u(C)!=="svelte-jqz7ws"&&(C.innerHTML=we),ne=s(e),h(Z.$$.fragment,e),le=s(e),W=m(e,"P",{"data-svelte-h":!0}),u(W)!=="svelte-jnvz89"&&(W.innerHTML=ye),ae=s(e),h(L.$$.fragment,e),se=s(e),U=m(e,"P",{"data-svelte-h":!0}),u(U)!=="svelte-kug5in"&&(U.innerHTML=_e),ie=s(e),h(G.$$.fragment,e),me=s(e),h(Y.$$.fragment,e),oe=s(e),X=m(e,"P",{}),xe(X).forEach(n),this.h()},h(){Me(f,"name","hf:doc:metadata"),Me(f,"content",Le)},m(e,t){Ce(document.head,f),l(e,V,t),l(e,Q,t),l(e,E,t),p($,e,t),l(e,F,t),l(e,c,t),l(e,S,t),l(e,b,t),l(e,N,t),l(e,w,t),l(e,I,t),p(y,e,t),l(e,R,t),l(e,_,t),l(e,z,t),p(x,e,t),l(e,B,t),l(e,M,t),l(e,A,t),p(T,e,t),l(e,D,t),l(e,v,t),l(e,O,t),p(H,e,t),l(e,q,t),p(k,e,t),l(e,K,t),p(J,e,t),l(e,ee,t),l(e,j,t),l(e,te,t),l(e,C,t),l(e,ne,t),p(Z,e,t),l(e,le,t),l(e,W,t),l(e,ae,t),p(L,e,t),l(e,se,t),l(e,U,t),l(e,ie,t),p(G,e,t),l(e,me,t),p(Y,e,t),l(e,oe,t),l(e,X,t),he=!0},p:ve,i(e){he||(r($.$$.fragment,e),r(y.$$.fragment,e),r(x.$$.fragment,e),r(T.$$.fragment,e),r(H.$$.fragment,e),r(k.$$.fragment,e),r(J.$$.fragment,e),r(Z.$$.fragment,e),r(L.$$.fragment,e),r(G.$$.fragment,e),r(Y.$$.fragment,e),he=!0)},o(e){d($.$$.fragment,e),d(y.$$.fragment,e),d(x.$$.fragment,e),d(T.$$.fragment,e),d(H.$$.fragment,e),d(k.$$.fragment,e),d(J.$$.fragment,e),d(Z.$$.fragment,e),d(L.$$.fragment,e),d(G.$$.fragment,e),d(Y.$$.fragment,e),he=!1},d(e){e&&(n(V),n(Q),n(E),n(F),n(c),n(S),n(b),n(N),n(w),n(I),n(R),n(_),n(z),n(B),n(M),n(A),n(D),n(v),n(O),n(q),n(K),n(ee),n(j),n(te),n(C),n(ne),n(le),n(W),n(ae),n(se),n(U),n(ie),n(me),n(oe),n(X)),n(f),g($,e),g(y,e),g(x,e),g(T,e),g(H,e),g(k,e),g(J,e),g(Z,e),g(L,e),g(G,e),g(Y,e)}}}const Le='{"title":"Sharing and Loading Models From the Hugging Face Hub","local":"sharing-and-loading-models-from-the-hugging-face-hub","sections":[{"title":"Authenticating","local":"authenticating","sections":[],"depth":2},{"title":"Sharing a Model","local":"sharing-a-model","sections":[],"depth":2},{"title":"Loading a Model","local":"loading-a-model","sections":[],"depth":2}],"depth":1}';function Ue(re){return He(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xe extends ke{constructor(f){super(),Je(this,f,Ue,We,Te,{})}}export{Xe as component};
